<?php
namespace OrganizationsManagement\Controller;
use OrganizationsManagement\Util\Utilities;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;

class Cidade extends Simple {

    private $serviceCidade;

    public function __construct(Service\Cidade $cityService){
        $this->serviceCidade = $cityService;
    }

    public function obtemPorSiglaEstado(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $filtro = $request->getFilterCriteria()->getConditions();
            $siglaEstado = Utilities::getValueInFilterDataSourceByName($filtro, 'STATE_SYMBOL', true);
            $cidades = array();

            if($siglaEstado){
                $cidades = $this->serviceCidade->obtemPorSiglaEstado($siglaEstado, $filtro);
            }
            
            $response->addDataSet(new DataSource\DataSet('cities', $cidades));
        } catch(\Exception $ex){
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
        }
    }
}