<?php
namespace OrganizationsManagement\Controller;
use OrganizationsManagement\Util\InstanceProvider;
use Zeedhi\Framework\Controller\Simple;
use OrganizationsManagement\Util\Utilities;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use OrganizationsManagement\Util\Messages;

class FileSendingSolicitationDelphi extends Simple
{
    public function findFileSendingSolicitationDelphi(DTO\Request\Filter $requisicao, DTO\Response $resposta){
        try{
            $page = $requisicao->getFilterCriteria()->getPage();
            $pageSize = $requisicao->getFilterCriteria()->getPageSize();
            $conditions = $requisicao->getFilterCriteria()->getConditions();
            $findFileSendingSolicitationDelphi = InstanceProvider::getService()->getFileUploadRequestDelphi()->findFileSendingSolicitationDelphi($conditions, $page, $pageSize);
            $resposta->addDataSet(new DataSource\DataSet('findFileSendingSolicitationDelphi', $findFileSendingSolicitationDelphi));
        } catch(\Exception $ex){
            $resposta->setError(new DTO\Response\Error($ex->getMessage(), 500));
        }
    }

    public function fileSendingSolicitationDownload(DTO\Request\DataSet $request, DTO\Response $response)
    {
        try{
            $rows = $request->getDataSet()->getRows();
            $data = InstanceProvider::getService()->getFileUploadRequestDelphi()->fileSendingSolicitationDownload($rows);
            if($data['status']) {
                $response->addDataSet(new DataSource\DataSet('fileSendingSolicitationDownload', array('status' => true)));
            } else {
                $response->addDataSet(new DataSource\DataSet('fileSendingSolicitationDownload', $data));
            }
        } catch(\Exception $ex){
            $response->setError(new DTO\Response\Error($ex->getMessage(), 500));
        }
    }

    public function downLoad(DTO\Request $request, DTO\Response $response)
    {
        try{
            InstanceProvider::getService()->getFileUploadRequestDelphi()->downLoad();
        } catch (\Exception $e){
            $response->addMessage(new DTO\Response\Message($e->getMessage()));
        }
    }


}