<?php

namespace OrganizationsManagement\Factory;

use OrganizationsManagement\Util\InstanceProvider;
use Teknisa\Model\Teknisa\Entities\OmProdutoRepositorio as EntidadeOmProdutoRepositorio;
use Teknisa\Model\Util\NovoCodigo;

class ProdutoRepositorio {
    public function save(EntidadeOmProdutoRepositorio $entity = null, $nrProdutoId, $nrExternalRepositoryId, $dsdirrelmigdb, $idAtivo) {
        $environment     = InstanceProvider::getEnvironment();
        $currentOperator = $environment->getCurrentUserId();
        $currentNrorg    = $environment->getCurrentOrganizationId();
        $dtAtual         = new \DateTime();

        if(!$entity) {
            $entity  = new EntidadeOmProdutoRepositorio();
            $newCode = NovoCodigo::geraCodigo($currentNrorg, "OmProdutoRepositorio", 1, 10, false, false);
            $entity->setId($newCode);
            $entity->setDtinclusao($dtAtual);
            $entity->setCdoperinclusao($currentOperator);
            $entity->setNrorginclusao($currentNrorg);
        } else {
            $entity->setDtultatu($dtAtual);
            $entity->setCdoperultatu($currentOperator);
            $entity->setNrorgultatu($currentNrorg);
        }

        $entity->setNrorg($currentNrorg);
        $entity->setNrprodutoId($nrProdutoId);
        $entity->setNrexternalRepositoryId($nrExternalRepositoryId);
        $entity->setDsdirrelmigdb($dsdirrelmigdb);
        $entity->setIdativo($idAtivo);

        return $entity;
    }
}